#%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
#%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
#%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
#%endif

#%if ! (0%{?fedora} > 16)
#%{!?ruby_vendorarchdir: %global ruby_vendorarchdir %(ruby -rrbconfig -e 'puts Config::CONFIG["vendorarchdir"] ')}
#%endif

# whether to build with PCRE or ICU (default = PCRE)
# %%global _with_icu 1

Name:			manatee-open
Version:		2.151.5
Release:		1%{?dist}
Summary:		Corpus management and query system

Group:			Applications/Databases
License:		GPLv2+
URL:			http://nlp.fi.muni.cz/trac/noske/
Source0:		http://corpora.fi.muni.cz/noske/src/manatee-open/%{name}-%{version}.tar.gz
Source1:		http://corpora.fi.muni.cz/noske/src/example-corpora/susanne-example-source.tar.bz2
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:		finlib >= 2.36.5
%{?fc24:Requires:       glibc-all-langpacks}
Requires:               glibc-common
Requires:		m4
Requires:		parallel

BuildRequires:		gcc-c++
BuildRequires:		python-devel
BuildRequires:		util-linux
BuildRequires:		java-devel
BuildRequires:		finlib-devel >= 2.36.5
BuildRequires:		ruby-devel
BuildRequires:		perl-devel
BuildRequires:		libtool-ltdl-devel
%if %{?_with_icu:1}%{!?_with_icu:0}
BuildRequires:		libicu-devel
%else
BuildRequires:		pcre-devel
%endif

%description
Manatee is a corpus management and query system.

%package python
Summary:	Python bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Group:		Applications/Databases

%description python
This package contains Python bindings for Manatee which are necessary if you
want to use Manatee from Python environment.

%package perl
Summary:	Perl bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Group:		Applications/Databases

%description perl
This package contains Perl bindings for Manatee which are necessary if you
want to use Manatee from Perl environment.

%package ruby
Summary:	Ruby bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Requires:	ruby  > 1.8
Group:		Applications/Databases

%description ruby
This package contains Ruby bindings for Manatee which are necessary if you
want to use Manatee from Ruby environment.

%package java
Summary:	Java bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Group:		Applications/Databases

%description java
This package contains Java JNI bindings for Manatee which are necessary if you
want to use Manatee from Java environment.

%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries

Requires:   %{name} = %{version}-%{release}

%description devel
This package contains development files for %{name}.

%package static
Summary:	Manatee static libaries
Group:		Development/Libraries

Requires:   %{name}-devel = %{version}-%{release}

%description static
This package contains Manatee static libraries.


%package susanne
Summary:	Example Manatee corpus SUSANNE %{name}
Group:		Applications/Databases
BuildArch:	noarch
Requires:   %{name} = %{version}-%{release}

%description susanne
This package contains example corpus SUSANNE encoded for Manatee.

%prep
%setup -q
%setup -q -T -D -a 1
find api/* -type f -exec sed -i 's|^#!/usr/bin/env |#!/usr/bin/|'  {} ';'
find api/* -type f -exec sed -i 's|^#! /usr/bin/env |#!/usr/bin/|'  {} ';'

%build
export RPM_OPT_FLAGS="$RPM_OPT_FLAGS -lltdl"
export CFLAGS="$RPM_OPT_FLAGS -lltdl"
export CXXFLAGS="$RPM_OPT_FLAGS -lltdl"

# don't use internal libltdl
rm -rf libltdl
sed -i 's|LIBLTDL=.*|LIBLTDL=|' configure 
sed -i 's|SUBDIRS = $(FINLIB_SUBDIRS) libltdl|SUBDIRS = $(FINLIB_SUBDIRS)|' Makefile.in

%if %{?_with_icu:1}%{!?_with_icu:0}
	%configure  --enable-cxxlib --with-gnu-ld --with-icu --enable-ltdl-install=no --enable-perl --enable-ruby --enable-java
%else
	%configure  --enable-cxxlib --with-gnu-ld --with-pcre --enable-ltdl-install=no --enable-perl --enable-ruby --enable-java
%endif

# remove rpaths
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%global manatee_dir %{_sharedstatedir}/manatee
export MANATEE_REGISTRY=%{manatee_dir}/registry
make %{?_smp_mflags}

# encode example SUSANNE corpus
mkdir susanne
export PATH=`pwd`/api:`pwd`/src:$PATH
export PYTHONPATH=`pwd`/api:`pwd`/api/.libs:$PYTHONPATH
api/compilecorp --recompile-corpus ./susanne-example-source/config susanne-example-source/source

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name *.la -delete

# install SUSANNE corpus
mkdir -p $RPM_BUILD_ROOT%{manatee_dir}/{data,vert,registry}
sed -i -e 's|PATH.*|PATH "%{manatee_dir}/data/susanne"|' -e 's|VERTICAL.*|VERTICAL "%{manatee_dir}/vert/susanne.vert"|' susanne-example-source/config
cp -p susanne-example-source/config $RPM_BUILD_ROOT%{manatee_dir}/registry/susanne
cp -rp susanne $RPM_BUILD_ROOT%{manatee_dir}/data/
rm -rf $RPM_BUILD_ROOT%{manatee_dir}/data/susanne/log
cp -p susanne-example-source/source $RPM_BUILD_ROOT%{manatee_dir}/vert/susanne.vert

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc AUTHORS README ChangeLog doc
%{_bindir}/corpinfo
%{_bindir}/encodevert
%{_bindir}/lscbgr
%{_bindir}/lsclex
%{_bindir}/manateesrv
%{_bindir}/mkdynattr
%{_bindir}/mknormattr
%{_bindir}/mknorms
%{_bindir}/mkvirt
%{_bindir}/mkalign
%{_bindir}/mksizes
%{_bindir}/dumpattrrev
%{_bindir}/dumpattrtext
%{_bindir}/dumpstructrng
%{_bindir}/dumpalign
%{_bindir}/lsalsize
%{_bindir}/mkregexattr
%{_libdir}/libmanatee.so.*
%dir %{manatee_dir}/data
%dir %{manatee_dir}/vert
%dir %{manatee_dir}/registry

%files python
%defattr(-,root,root,-)
%{_bindir}/addwcattr
%{_bindir}/concinfo
%{_bindir}/corpquery
%{_bindir}/decodevert
%{_bindir}/freqs
%{_bindir}/lslexarf
%{_bindir}/lsslex
%{_bindir}/mksubc
%{_bindir}/mkstats
%{_bindir}/compilecorp
%{_bindir}/corpcheck
%{_bindir}/devirt
%{_bindir}/par2tokens
%{_bindir}/parencodevert
%{_bindir}/tokens2dict
%{_bindir}/mkbidict
%{python_sitearch}/*  

%files java
%defattr(-,root,root,-)
%{_libdir}/manatee/
%doc api/example.java

%files perl
%defattr(-,root,root,-)
%{perl_vendorarch}/*
%doc api/corpquery.pl

%files ruby
%defattr(-,root,root,-)
%{ruby_vendorarchdir}/*

%files devel
%defattr(-,root,root,-)
%{_includedir}/manatee/
%{_libdir}/*.so

%files static
%defattr(-,root,root,-)
%{_libdir}/*.a

%files susanne
%defattr(-,root,root,-)
%{manatee_dir}/data/susanne/
%{manatee_dir}/vert/susanne.vert
%{manatee_dir}/registry/susanne

%changelog
* Wed Jul 12 2017 Jan Bušta - 2.151.5-1
- Update to 2.151.5

* Mon Apr 10 2017 Jan Busta - 2.150-1
- Update to 2.150

* Mon Apr 03 2017 Jan Busta - 2.149.3-4
- rebuilt

* Mon Apr 03 2017 Jan Busta - 2.149.3-3
- rebuilt

* Mon Apr 03 2017 Jan Busta - 2.149.3-2
- rebuilt

* Thu Feb 16 2017 Jan Busta - 2.146.3-2
- rebuilt

* Thu Feb 16 2017 Jan Busta - 2.146.3-1
- Update to 2.146.3

* Mon Oct 10 2016 Jan Busta - 2.139.3-6
- rebuilt

* Mon Oct 10 2016 Jan Busta - 2.139.3-5
- rebuilt

* Mon Oct 10 2016 Jan Busta - 2.139.3-4
- rebuilt

* Wed Oct 05 2016 Jan Busta - 2.139.3-3
- rebuilt

* Wed Oct 05 2016 Jan Busta - 2.139.3-2
- rebuilt

* Tue Sep 13 2016 Jan Busta - 2.139.3-1
- Update to 2.139.3

* Fri Nov 13 2015 Jan Busta - 2.130.6-3
- rebuilt

* Fri Nov 13 2015 Jan Busta - 2.130.6-2
- rebuilt

* Thu Nov 12 2015 Jan Busta - 2.130.6-1
- Update to 2.130.6

* Mon Oct 05 2015 Jan Busta - 2.129.2-4
- rebuilt

* Mon Oct 05 2015 Jan Busta - 2.129.2-3
- rebuilt

* Mon Oct 05 2015 Jan Busta - 2.129.2-2
- rebuilt

* Mon Oct 05 2015 Jan Busta - 2.129.2-1
- Update to 2.129.2

* Wed Apr 08 2015 Jan Busta - 2.121.1-3
- rebuilt

* Wed Apr 08 2015 Jan Busta - 2.121.1-2
- rebuilt

* Wed Apr 08 2015 Jan Busta - 2.121.1-1
- Update to 2.121.1

* Wed Apr 08 2015 Jan Busta - 2.121-4
- rebuilt

* Wed Apr 08 2015 Jan Busta - 2.121-3
- rebuilt

* Tue Apr 07 2015 Jan Busta - 2.121-2
- rebuilt

* Tue Apr 07 2015 Jan Busta - 2.121-1
- Update to 2.121

* Wed Apr 16 2014 Milos Jakubicek <milos.jakubicek@sketchengine.co.uk> - 2.107.1-1
- Update to 2.107.1

* Fri Apr 16 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.30-1
- Update to 2.30
- Fix installing ruby and perl API's according to changes in 2.30
- Fix installing manatee.so as part of Perl API => not noarch anymore

* Fri Apr 09 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.29.1-1
- Update to 2.29.1
- Compilecorp included to manatee

* Sun Feb 14 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.28-1
- Update to 2.28
- Fix installing manatee-python into python_sitearch, not python_sitelib
  (it's arch-dependent)
- Move python scripts in %%{_bindir} into the python-subpackage
